/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] is_user_alive
v1.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>



#define NO_RECOIL_WEAPONS_BITSUM (1<<2 | 1<<CSW_KNIFE | 1<<CSW_HEGRENADE | 1<<CSW_FLASHBANG | 1<<CSW_SMOKEGRENADE | 1<<CSW_C4)

new g_item_no_recoil, g_has_no_recoil[33], cvar_round, cvar_give

public plugin_init()
{
	register_plugin("[ZPNM] No Recoil", "1.1.3", "BW-Chocolate")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	register_dictionary("zpnm_no_recoil.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_item_no_recoil = zp_register_extra_item("No Recoil", 11, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
	
	new i, szWeapon[33];
	
	for (i = CSW_P228; i <= CSW_P90; i++)
		if (!(NO_RECOIL_WEAPONS_BITSUM & (1<<i)) && get_weaponname(i, szWeapon, 19))
			RegisterHam(Ham_Weapon_PrimaryAttack, szWeapon, "fwdPrimaryAttack_post", 1);
	
	cvar_round = register_cvar("zpnm_no_recoil_round", "0")
	cvar_give = register_cvar("zpnm_no_recoil_give", "0")
}

public client_disconnect(id)
	drop_item(id)

public zp_extra_item_selected(id, itemid)
{
	if (itemid == g_item_no_recoil)
	{
		if (g_has_no_recoil[id] || get_pcvar_num(cvar_give))
		{
			zp_colored_print(id, "^3%L", id, "ZPNM_NO_RECOIL_HAVE_ALREADY")
			return ZP_PLUGIN_HANDLED;
		}
		else
		{
			g_has_no_recoil[id] = true
			zp_colored_print(id, "^4%L", id, "ZPNM_NO_RECOIL_HAVE")
		}
	}
	
	return PLUGIN_CONTINUE;
}

public zpnm_user_spawn_post(id)
	if (get_pcvar_num(cvar_give))
		g_has_no_recoil[id] = true
	else if (get_pcvar_num(cvar_round))
		g_has_no_recoil[id] = false

public fwdPrimaryAttack_post(ent)
{
	static id;
	id = pev(ent, pev_owner);
	
	if (g_has_no_recoil[id])
		set_pev(id, pev_punchangle, Float:{0.0, 0.0, 0.0});
}

public zp_user_infected_post(id)
	drop_item(id)

public zp_user_humanized_post(id)
	if (get_pcvar_num(cvar_give))
		g_has_no_recoil[id] = true

public fwHamKilledPlayer(id)
	if (zp_has_round_started())
		drop_item(id)

#include <engine>

new w_item[] = "models/w_security.mdl"

public plugin_precache()
{
	precache_model(w_item)
	
	new tmodel[64]
	formatex(tmodel, 63, w_item)
	copy(tmodel[strlen(tmodel)-4], charsmax(tmodel) - (strlen(tmodel)-4), "T.mdl")
	if (file_exists(tmodel)) engfunc(EngFunc_PrecacheModel, tmodel)
}

public drop_item(id)
{
	if (!g_has_no_recoil[id])
		return;
	
	new Float:origin[3]
	entity_get_vector(id, EV_VEC_origin, origin)
	
	new bazooka = create_entity("info_target")
	
	entity_set_string(bazooka, EV_SZ_classname, "zpnm_no_recoil")
	entity_set_model(bazooka, w_item)
	fm_set_rendering(bazooka)
	
	entity_set_size(bazooka, Float:{ -16.0, -16.0, -16.0 }, Float:{ 16.0, 16.0, 16.0 })
	entity_set_int(bazooka, EV_INT_solid, 1)
	
	entity_set_int(bazooka, EV_INT_movetype, 6)
	
	entity_set_vector(bazooka, EV_VEC_origin, origin)
	
	g_has_no_recoil[id] = false
}

public pfn_touch(ptr, ptd)
{
	if (!is_valid_ent(ptr))
		return;
	
	static classname[32]
	entity_get_string(ptr, EV_SZ_classname, classname, 31)
	
	if (equali(classname, "zpnm_no_recoil"))
	{
		if (!is_user_alive(ptd) || zp_get_user_zombie(ptd) || g_has_no_recoil[ptd])
			return;
		
		g_has_no_recoil[ptd] = true
		
		zp_colored_print(ptd, "^4%L", ptd, "ZPNM_NO_RECOIL_HAVE")
		
		engfunc(EngFunc_RemoveEntity, ptr)
	}
}

public event_round_start()
{
	new nextitem = -1
	nextitem = find_ent_by_class(-1, "zpnm_no_recoil")
	
	while (nextitem)
	{
		if (is_valid_ent(nextitem))
			engfunc(EngFunc_RemoveEntity, nextitem)
		
		nextitem = find_ent_by_class(-1, "zpnm_no_recoil")
	}
}


// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(entity)
{
	static Float:color[3]
	color[0] = 0.0
	color[1] = 255.0
	color[2] = 0.0
	
	set_pev(entity, pev_renderfx, kRenderFxGlowShell)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, kRenderNormal)
	set_pev(entity, pev_renderamt, random_float(57.7, 75.7))
}
