/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v0.0.7
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_szEnterSprites[][] =
{
	"sprites/b-tele1.spr",
//	"sprites/cnt1.spr",
//	"sprites/d-tele1.spr",
//	"sprites/e-tele1.spr",
//	"sprites/tele1.spr",
	"sprites/enter1.spr",
	"sprites/portal1.spr"
}
const g_iSizeEnter = sizeof g_szEnterSprites - 1
new g_iEnterID[g_iSizeEnter + 1]

new g_szExitSprites[][] =
{
//	"sprites/nhth1.spr",
	"sprites/c-tele1.spr",
	"sprites/exit1.spr"
}
const g_iSizeExit = sizeof g_szExitSprites - 1
new g_iExitID[g_iSizeExit + 1]

new g_szTeleportSounds[][] = 
{
	"debris/beamstart7.wav",
	"debris/beamstart8.wav",
	"debris/beamstart9.wav",
	"debris/beamstart10.wav"
}
const g_iSizeSounds = sizeof g_szTeleportSounds - 1

new g_item_teleport//, g_protect[33]

public plugin_precache()
{
	new i
	
	for (i = 0; i <= g_iSizeEnter; i++)
		g_iEnterID[i] = precache_model(g_szEnterSprites[i])
	
	for (i = 0; i <= g_iSizeExit; i++)
		g_iExitID[i] = precache_model(g_szExitSprites[i])
	
	for (i = 0; i <= g_iSizeSounds; i++)
		precache_sound(g_szTeleportSounds[i])
}

public plugin_init()
{
	register_plugin("[ZPNM] Item Teleport", "0.0.7", "D i 5 7 i n c T")
	
	g_item_teleport = zp_register_extra_item("Teleport to spawn", 19, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
//	
//	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public client_disconnect(iID)
{
	remove_task(iID)
//	g_protect[iID] = false
}

public zp_user_humanized_post(iID)
{
	remove_task(iID)
//	g_protect[iID] = false
}
/*
public fw_TakeDamage(victim, inflictor, attacker)
{
	if (g_protect[victim])
		return HAM_SUPERCEDE;
	
	static maxplayers
	if (!maxplayers)
		maxplayers = get_maxplayers() + 1
	
	if ((0 < attacker < maxplayers) && g_protect[attacker])
		return HAM_SUPERCEDE;
	
	return HAM_IGNORED;
}

public zp_user_infect_attempt(iID)
{
	if (g_protect[iID])
		return ZP_PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}
*/
public zp_user_infected_post(iID)
{
	remove_task(iID)
//	g_protect[iID] = false
}

public unprotect(iID)
{
//	g_protect[iID] = false
	fm_set_rendering(iID)
}

public zpnm_user_spawn_post(iID)
{
	remove_task(iID)
//	g_protect[iID] = false
}

public fwHamKilledPlayer(const iID)
{
	remove_task(iID)
//	g_protect[iID] = false
}

public zp_extra_item_selected(iID, item)
{
	if (item != g_item_teleport)
		return PLUGIN_CONTINUE;
	
	if (task_exists(iID)) //g_protect[iID]
	{
		client_print(iID, print_center, "Please wait for teleport cooldown to end...")
		
		return ZP_PLUGIN_HANDLED;
	}
	
//	g_protect[iID] = true
	zpnm_set_user_no_damage(iID, 7.57)
	fm_set_rendering(iID, kRenderFxNone, 255, 255, 255, kRenderTransTexture)
	set_task(7.57, "unprotect", iID)
	
	new szOrigin[3]
	
	get_user_origin(iID, szOrigin)
	PlaySprite(szOrigin, 0)
	
	zpnm_teleport_user(iID)
	client_cmd(0, "spk ^"%s^"", g_szTeleportSounds[random_num(0, g_iSizeSounds)])
	
	get_user_origin(iID, szOrigin)
	PlaySprite(szOrigin, 1)
	
	return PLUGIN_CONTINUE;
}

public PlaySprite(szOrigin[3], iType)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(szOrigin[0])
	write_coord(szOrigin[1])
	write_coord(szOrigin[2])
	write_short(!iType ? g_iEnterID[random_num(0, g_iSizeEnter)] : g_iExitID[random_num(0, g_iSizeExit)])
	write_byte(8)
	write_byte(255)
	message_end()
}

// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 0)
{
	static Float:color[3]
	color[0] = float(r)
	color[1] = float(g)
	color[2] = float(b)
	
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, float(amount))
}
