/*
To do:

T = needs testing
X = done
- = cancelled

[X] zp43 support
[X] customizable information shown depending on the aimer and target type
[X] constant iID for fwEventStatusValueHide
[X] remove_task on disconnect only if ZP43 compatibility isn't enabled
[X] fix armor lang missing on default ZP43(register zombie_plague_nightmare.txt anyway)
v2.0.3
[T] use a single hud channel instead of auto (-1)
[T] fix information not disappearing after switching spectating modes (free look / chase / first person)
[T] fix fwEventStatusValueShow triggering twice, first with random information
[T] fix hud not showing when aiming at an enemy after previously aiming at a teammate
[T] make the hud update in real time as the player stats change and is being aimed on
[T] get rid of hud sync in order to avoid flickering or hiding huds
[T] use fakemeta client info changed post
[T] fix player name string being 1 char short
[T] letter flags instead of raw bitsum numbers
[T] customizable information and hud refresh and duration interval
[T] amxx 183 disconnect support
[T] optimize client_putinserver (string code)
v2.1.5
[ ] customizable hud color for when aiming on team or enemy
[ ] zp5 support
[ ] optimize fwEventStatusValueShow (remove unnecessary checks)
[ ] customizable hud effects, position, hold time, etc
[ ] customizable information shown depending on aimer access
[ ] make sure we cover all disconnect cases
[ ] ability to choose between hud and statusvalue
[ ] first person spectator support
[ ] default zp43 mode by default but add aditional zpnm support if detected
[ ] support for arkshine's geoip+ city if native and database file exist
[ ] 
*/

// Modules
#include <amxmodx>
#include <geoip>
#include <fakemeta>
#include <hamsandwich>

//#define g_DefZP43Compatibility

// Plug-in APIs
#include <cs_ham_bots_api>
#if !defined g_DefZP43Compatibility
#include <zombieplaguenightmare>
#else
#include <zombieplague>
#endif

// Stocks
#include <bitsums>
//#include <D7Debug>

//const PEV_SPEC_TARGET = pev_iuser2
//
enum _:g_iBsInfo (<<= 1)
{
	g_iBitName = 1, //a
	g_iBitClass, //b
	g_iBitHealth, //c
	g_iBitArmor, //d
	g_iBitAmmoPacks, //e
	g_iBitCountry //f
}

new g_szName[33][32], g_szClass[33][32], g_szCountry[33][51],//g_iMaxPlayers, 

g_iIDPCvarInfoHTeam, g_iIDPCvarInfoHEnemy, g_iIDPCvarInfoZTeam, g_iIDPCvarInfoZEnemy, g_iIDPCvarInfoNeutral, g_iIDPCvarInfoHUDInterval,
g_iCacheCvarInfoHTeam, g_iCacheCvarInfoHEnemy, g_iCacheCvarInfoZTeam, g_iCacheCvarInfoZEnemy, g_iCacheCvarInfoNeutral, Float:g_fCacheCvarInfoHUDInterval,

g_iIDPCvarHudColorRH, g_iIDPCvarHudColorGH, g_iIDPCvarHudColorBH,
g_iIDPCvarHudColorRZ, g_iIDPCvarHudColorGZ, g_iIDPCvarHudColorBZ,
g_iIDPCvarHudColorRS, g_iIDPCvarHudColorGS, g_iIDPCvarHudColorBS,
g_iCacheCvarHudColorRH, g_iCacheCvarHudColorGH, g_iCacheCvarHudColorBH,
g_iCacheCvarHudColorRZ, g_iCacheCvarHudColorGZ, g_iCacheCvarHudColorBZ,
g_iCacheCvarHudColorRS, g_iCacheCvarHudColorGS, g_iCacheCvarHudColorBS,

g_iBsConnected, g_iBsBot, g_iBsAlive, g_iBsZombie;

#if !defined g_DefZP43Compatibility
new g_iAmmoPacks[33];
#endif

enum (+= 32)
{
	g_iIDTaskUpdateHUD = 33
}

public plugin_init()
{
	register_plugin("[ZPNM] Aim Info", "2.1.5", "D i 5 7 i n c T, @bdul!, Sn!ff3r, Numb, NiHiLaNTh")
	
	register_event("HLTV", "fwEventHLTVRoundStart", "a", "1=0", "2=0")
	register_event("StatusValue", "fwEventStatusValueShow", "b", "1=2", "2>0") // thanks to hlstriker
	register_event("StatusValue", "fwEventStatusValueHide", "b", "1=1", "2=0") // thanks to Emp`
	
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
	
	#if defined g_DefZP43Compatibility
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayer", 1)
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayer", 1)
	#endif
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	register_forward(FM_ClientUserInfoChanged, "fwFmClientUserInfoChanged", 1)
	
	g_iIDPCvarInfoHTeam = register_cvar("D7ZPAimInfoHTeam", "abcdef");
	g_iIDPCvarInfoHEnemy = register_cvar("D7ZPAimInfoHEnemy", "abf");
	g_iIDPCvarInfoZTeam = register_cvar("D7ZPAimInfoZTeam", "abcef");
	g_iIDPCvarInfoZEnemy = register_cvar("D7ZPAimInfoZEnemy", "abf");
	g_iIDPCvarInfoNeutral = register_cvar("D7ZPAimInfoNeutral", "abcdef");
	
	g_iIDPCvarHudColorRH = register_cvar("D7ZPAimInfoHudColorRH", "255");
	g_iIDPCvarHudColorGH = register_cvar("D7ZPAimInfoHudColorGH", "0");
	g_iIDPCvarHudColorBH = register_cvar("D7ZPAimInfoHudColorBH", "0");
	
	g_iIDPCvarHudColorRZ = register_cvar("D7ZPAimInfoHudColorRZ", "0");
	g_iIDPCvarHudColorGZ = register_cvar("D7ZPAimInfoHudColorGZ", "0");
	g_iIDPCvarHudColorBZ = register_cvar("D7ZPAimInfoHudColorBZ", "255");
	
	g_iIDPCvarHudColorRS = register_cvar("D7ZPAimInfoHudColorRS", "0");
	g_iIDPCvarHudColorGS = register_cvar("D7ZPAimInfoHudColorGS", "255");
	g_iIDPCvarHudColorBS = register_cvar("D7ZPAimInfoHudColorBS", "0");
	
	g_iIDPCvarInfoHUDInterval = register_cvar("D7ZPAimInfoHudInterval", "0.5");
	
	//ftD7Log(_, _, "[plugin_init] g_iBsInfo: %d.", g_iBsInfo)
	//ftD7Log(_, _, "[plugin_init] g_iBitName: %d.", g_iBitName)
	//ftD7Log(_, _, "[plugin_init] g_iBitClass: %d.", g_iBitClass)
	//ftD7Log(_, _, "[plugin_init] g_iBitHealth: %d.", g_iBitHealth)
	//ftD7Log(_, _, "[plugin_init] g_iBitArmor: %d.", g_iBitArmor)
	//ftD7Log(_, _, "[plugin_init] g_iBitAmmoPacks: %d.", g_iBitAmmoPacks)
	//ftD7Log(_, _, "[plugin_init] g_iBitCountry: %d.", g_iBitCountry)
	
	//g_iMaxPlayers = get_maxplayers();
}

public fwEventHLTVRoundStart()
{
	static szInfo[7];
	
	get_pcvar_string(g_iIDPCvarInfoHTeam, szInfo, charsmax(szInfo))
	g_iCacheCvarInfoHTeam = read_flags(szInfo);
	
	get_pcvar_string(g_iIDPCvarInfoHEnemy, szInfo, charsmax(szInfo))
	g_iCacheCvarInfoHEnemy = read_flags(szInfo);
	
	
	get_pcvar_string(g_iIDPCvarInfoZTeam, szInfo, charsmax(szInfo))
	g_iCacheCvarInfoZTeam = read_flags(szInfo);
	
	get_pcvar_string(g_iIDPCvarInfoZEnemy, szInfo, charsmax(szInfo))
	g_iCacheCvarInfoZEnemy = read_flags(szInfo);
	
	
	get_pcvar_string(g_iIDPCvarInfoNeutral, szInfo, charsmax(szInfo))
	g_iCacheCvarInfoNeutral = read_flags(szInfo);
	
	
	
	g_iCacheCvarHudColorRH = get_pcvar_num(g_iIDPCvarHudColorRH);
	g_iCacheCvarHudColorGH = get_pcvar_num(g_iIDPCvarHudColorGH);
	g_iCacheCvarHudColorBH = get_pcvar_num(g_iIDPCvarHudColorBH);
	
	g_iCacheCvarHudColorRZ = get_pcvar_num(g_iIDPCvarHudColorRZ);
	g_iCacheCvarHudColorGZ = get_pcvar_num(g_iIDPCvarHudColorGZ);
	g_iCacheCvarHudColorBZ = get_pcvar_num(g_iIDPCvarHudColorBZ);
	
	g_iCacheCvarHudColorRS = get_pcvar_num(g_iIDPCvarHudColorRS);
	g_iCacheCvarHudColorGS = get_pcvar_num(g_iIDPCvarHudColorGS);
	g_iCacheCvarHudColorBS = get_pcvar_num(g_iIDPCvarHudColorBS);
	
	
	
	g_fCacheCvarInfoHUDInterval = get_pcvar_float(g_iIDPCvarInfoHUDInterval);
}

public client_authorized(iID)
{
	if (is_user_bot(iID))
		bitsum_add(g_iBsBot, iID)
}

public client_putinserver(iID)
{
	bitsum_add(g_iBsConnected, iID)
	
	static szIP[16];
	get_user_ip(iID, szIP, charsmax(szIP), 1)
	geoip_country(szIP, g_szCountry[iID])
	
	if (equali(g_szCountry[iID], "error"))
	{
		g_szCountry[iID] = "N/A"
		
		return;
	}
	
	static szCountryShort[4];
	geoip_code3_ex(szIP, szCountryShort)
	format(g_szCountry[iID], charsmax(g_szCountry[]), "%s(%s)", g_szCountry[iID], szCountryShort)
}

#if AMXX_VERSION_NUM <= 182
public client_disconnect(iID)
#else
public client_disconnected(iID)
#endif
{
	#if !defined g_DefZP43Compatibility
	remove_task(iID)
	#endif
	
	remove_task(iID + g_iIDTaskUpdateHUD)
	
	bitsum_del(g_iBsConnected, iID)
	bitsum_del(g_iBsBot, iID)
	bitsum_del(g_iBsAlive, iID)
	bitsum_del(g_iBsZombie, iID)
}

public fwFmClientUserInfoChanged(const iID)//, const iIDBuffer
{
	if (!bitsum_get(g_iBsConnected, iID))
		return;
	
	get_user_name(iID, g_szName[iID], charsmax(g_szName[]))
}

#if !defined g_DefZP43Compatibility
public zpnm_user_spawn_post(iID)
{
	bitsum_add(g_iBsAlive, iID)
	bitsum_del(g_iBsZombie, iID)
	
	zpnm_get_class_name(1, zpnm_get_user_human_class(iID), g_szClass[iID], charsmax(g_szClass[]))
}
#else
public fwHamSpawnPlayer(const iID)
{
	if (is_user_alive(iID))
		bitsum_add(g_iBsAlive, iID)
	
	if (zp_get_user_zombie(iID))
		return;
	
	bitsum_del(g_iBsZombie, iID)
	
	g_szClass[iID] = "CLASS_HUMAN"
}
#endif

#if !defined g_DefZP43Compatibility
public zp_user_infected_post(iID, iIDInfector, bNemesis, bAssassin)
{
	bitsum_add(g_iBsZombie, iID)
	
	if (!bAssassin)
	{
		if (!bNemesis)
		{
			zpnm_get_class_name(0, zp_get_user_zombie_class(iID), g_szClass[iID], charsmax(g_szClass[]))
		}
		else
		{
			g_szClass[iID] = "CLASS_NEMESIS"
		}
	}
	else
	{
		g_szClass[iID] = "CLASS_ASSASSIN"
	}
}
#else
public zp_user_infected_post(iID, iIDInfector, bNemesis)
{
	bitsum_add(g_iBsZombie, iID)
	
	if (!bNemesis)
	{
		g_szClass[iID] = "CLASS_ZOMBIE"
	}
	else
	{
		g_szClass[iID] = "CLASS_NEMESIS"
	}
}
#endif

#if !defined g_DefZP43Compatibility
public zp_user_humanized_post(iID, bSurvivor, bSniper)
{
	bitsum_del(g_iBsZombie, iID)
	
	if (!bSniper)
	{
		if (!bSurvivor)
		{
			zpnm_get_class_name(1, zpnm_get_user_human_class(iID), g_szClass[iID], charsmax(g_szClass[]))
		}
		else
		{
			g_szClass[iID] = "CLASS_SURVIVOR"
		}
	}
	else
	{
		g_szClass[iID] = "CLASS_SNIPER"
	}
}
#else
public zp_user_humanized_post(iID, bSurvivor)
{
	bitsum_del(g_iBsZombie, iID)
	
	if (!bSurvivor)
	{
		g_szClass[iID] = "CLASS_HUMAN"
	}
	else
	{
		g_szClass[iID] = "CLASS_SURVIVOR"
	}
}
#endif

public fwHamKilledPlayer(const iID)
{
	bitsum_del(g_iBsAlive, iID)
	
	remove_task(iID + g_iIDTaskUpdateHUD)
}

#if !defined g_DefZP43Compatibility
public zpnm_user_get_ammo_packs(iID)
{
	g_iAmmoPacks[iID] = zp_get_user_ammo_packs(iID);
}

public zp_extra_item_selected(iID, iItemID, bIgnoreCost, iCost)
{
	if (bIgnoreCost || !iCost)
		return;
	
	remove_task(iID)
	set_task(0.1, "fwTaskUpdateAmmoPacks", iID)
}

public fwTaskUpdateAmmoPacks(const iID)
{
	g_iAmmoPacks[iID] = zp_get_user_ammo_packs(iID);
}
#endif

public fwEventStatusValueShow(const iID)
{
	if (!bitsum_get(g_iBsConnected, iID)
	|| bitsum_get(g_iBsBot, iID)
	|| pev(iID, pev_iuser2))
		return;
/*	
	new iIDTeam = read_data(1);
	
	if (iIDTeam == 3)
		return;*/
	
	new iIDAim = read_data(2);
	
	if (!bitsum_get(g_iBsAlive, iIDAim))//!(1 <= iIDAim <= g_iMaxPlayers) || 
	{
		remove_task(iID + g_iIDTaskUpdateHUD)
		
		return;
	}
	
	new szInfo[2];
	szInfo[0] = iIDAim;
	
	fwTaskUpdateHUD(szInfo, iID + g_iIDTaskUpdateHUD)
	
	remove_task(iID + g_iIDTaskUpdateHUD)
	set_task(g_fCacheCvarInfoHUDInterval, "fwTaskUpdateHUD", iID + g_iIDTaskUpdateHUD, szInfo, charsmax(szInfo), "b")
}

public fwTaskUpdateHUD(const szInfo[], iID)
{
	iID -= g_iIDTaskUpdateHUD;
	
	if (!bitsum_get(g_iBsAlive, iID) && pev(iID, pev_iuser2))
	{
		remove_task(iID + g_iIDTaskUpdateHUD)
		
		return;
	}
	
	new iBsInfo, iIDAim = szInfo[0];
	
	if (!bitsum_get(g_iBsAlive, iID))
	{
		set_hudmessage(g_iCacheCvarHudColorRS, g_iCacheCvarHudColorGS, g_iCacheCvarHudColorBS, -1.0, 0.5377, 1, g_fCacheCvarInfoHUDInterval, g_fCacheCvarInfoHUDInterval + 0.01, 0.0, 0.0, 2)
		
		iBsInfo = g_iCacheCvarInfoNeutral;
		//ftD7Log(_, _, "[fwEventStatusValueShow] iID %d is dead. iBsInfo: %d.", iID, iBsInfo)
	}
	else if (!bitsum_get(g_iBsZombie, iID))
	{
		//ftD7Log(_, _, "[fwEventStatusValueShow] iID %d is human.", iID)
		set_hudmessage(g_iCacheCvarHudColorRH, g_iCacheCvarHudColorGH, g_iCacheCvarHudColorBH, -1.0, 0.5377, 1, g_fCacheCvarInfoHUDInterval, g_fCacheCvarInfoHUDInterval + 0.01, 0.0, 0.0, 2)
		
		if (!bitsum_get(g_iBsZombie, iIDAim))
		{
			iBsInfo = g_iCacheCvarInfoHTeam;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iIDAim %d is human. iBsInfo: %d.", iIDAim, iBsInfo)
		}
		else
		{
			iBsInfo = g_iCacheCvarInfoHEnemy;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iIDAim %d is zombie. iBsInfo: %d.", iIDAim, iBsInfo)
		}
	}
	else
	{
		//ftD7Log(_, _, "[fwEventStatusValueShow] iID %d is zombie.", iID)
		set_hudmessage(g_iCacheCvarHudColorRZ, g_iCacheCvarHudColorGZ, g_iCacheCvarHudColorBZ, -1.0, 0.5377, 1, g_fCacheCvarInfoHUDInterval, g_fCacheCvarInfoHUDInterval + 0.01, 0.0, 0.0, 2)
		
		if (bitsum_get(g_iBsZombie, iIDAim))
		{
			iBsInfo = g_iCacheCvarInfoZTeam;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iIDAim %d is zombie. iBsInfo: %d.", iIDAim, iBsInfo)
		}
		else
		{
			iBsInfo = g_iCacheCvarInfoZEnemy;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iIDAim %d is human. iBsInfo: %d.", iIDAim, iBsInfo)
		}
	}
	
	static szMessage[256];
	new iPosition;
	
	if (iBsInfo & g_iBitName)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%s]^n", g_szName[iIDAim]);
		//ftD7Log(_, _, "[%s]", g_szName[iIDAim]);
	}
	
	if (iBsInfo & g_iBitClass)
	{
		#if !defined g_DefZP43Compatibility
		if (contain(g_szClass[iIDAim], "CLASS_") == -1)
		{
			iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %s]^n", iID, "CLASS_CLASS", g_szClass[iIDAim]);
			//ftD7Log(_, _, "[%L %s]", iID, "CLASS_CLASS", g_szClass[iIDAim]);
		}
		else
		{
		#endif
			iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %L]^n", iID, "CLASS_CLASS", iID, g_szClass[iIDAim]);
			//ftD7Log(_, _, "[%L %L]", iID, "CLASS_CLASS", iID, g_szClass[iIDAim]);
		#if !defined g_DefZP43Compatibility
		}
		#endif
	}
	
	if (iBsInfo & g_iBitHealth)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L: %d]^n", iID, "ZOMBIE_ATTRIB1", get_user_health(iIDAim));
		//ftD7Log(_, _, "[%L: %d]", iID, "ZOMBIE_ATTRIB1", get_user_health(iIDAim));
	}
	
	if (iBsInfo & g_iBitArmor)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L: %d]^n", iID, "ZOMBIE_ATTRIB5", get_user_armor(iIDAim));
		//ftD7Log(_, _, "[%L: %d]", iID, "ZOMBIE_ATTRIB5", get_user_armor(iIDAim));
	}
	
	if (iBsInfo & g_iBitAmmoPacks)
	{
		#if !defined g_DefZP43Compatibility
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %d]^n", iID, "AMMO_PACKS1", g_iAmmoPacks[iIDAim]);
		//ftD7Log(_, _, "[%L %d]", iID, "AMMO_PACKS1", g_iAmmoPacks[iIDAim]);
		#else
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %d]^n", iID, "AMMO_PACKS1", zp_get_user_ammo_packs(iIDAim));
		//ftD7Log(_, _, "[%L %d]", iID, "AMMO_PACKS1", zp_get_user_ammo_packs(iIDAim));
		#endif
	}
	
	if (iBsInfo & g_iBitCountry)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%s]", g_szCountry[iIDAim]);
		//ftD7Log(_, _, "[%s]", g_szCountry[iIDAim]);
	}
	
	if (!iBsInfo)
		return;
	
	show_hudmessage(iID, szMessage)
}

public fwEventStatusValueHide(const iID)
{
	remove_task(iID + g_iIDTaskUpdateHUD)
}
