#include <amxmodx>
#include <geoip>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplaguenightmare>

//#define DEBUG

//#define ZP_COMPAT

//const PEV_SPEC_TARGET = pev_iuser2
//
new g_msgSyncHUD, g_szName[33][31], g_szClass[33][32], g_szCountry[33][51]
new g_nvg_zred, g_nvg_zgreen, g_nvg_zblue, g_nvg_hred, g_nvg_hgreen, g_nvg_hblue

public plugin_init()
{
	register_plugin("[ZPNM] Aim Info", "1.5.5", "D i 5 7 i n c T, @bdul!, Sn!ff3r, Numb, NiHiLaNTh")
	
	register_event("StatusValue", "ShowStatus", "b", "1!3", "2>0")
	register_event("StatusValue", "HideStatus", "b", "2=0")
	
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
	
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
	
	g_msgSyncHUD = CreateHudSyncObj()
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	g_nvg_zred = get_cvar_num("zp_nvg_color_R")
	g_nvg_zgreen = get_cvar_num("zp_nvg_color_G")
	g_nvg_zblue = get_cvar_num("zp_nvg_color_B")
	g_nvg_hred = get_cvar_num("zp_nvg_hum_color_R")
	g_nvg_hgreen = get_cvar_num("zp_nvg_hum_color_G")
	g_nvg_hblue = get_cvar_num("zp_nvg_hum_color_B")
}

public client_putinserver(id)
{
	static szIP[16];
	get_user_ip(id, szIP, 15, 1)
	geoip_country(szIP, g_szCountry[id])
	
	if (equali(g_szCountry[id], "error"))
	{
		g_szCountry[id] = "Country N/A"
		
		return;
	}
	
	new szCountryShort[4];
	geoip_code3_ex(szIP, szCountryShort)
	format(g_szCountry[id], 50, "%s(%s)", g_szCountry[id], szCountryShort)
}

public client_infochanged(id)
{
	if (!is_user_connected(id))
		return;
	
	get_user_info(id, "name", g_szName[id], 30)
}

public zpnm_user_spawn_post(id)
#if !defined ZP_COMPAT
	zpnm_get_class_name(1, zpnm_get_user_human_class(id), g_szClass[id], 31)
#else
	g_szClass[id] = "CLASS_HUMAN"
#endif

public zp_user_infected_post(id, infector, nemesis, assassin)
{
	if (!assassin)
	{
		if (!nemesis)
		{
#if !defined ZP_COMPAT
			zpnm_get_class_name(0, zp_get_user_zombie_class(id), g_szClass[id], 31)
#else
			g_szClass[id] = "CLASS_ZOMBIE"
#endif
		}
		else
			g_szClass[id] = "CLASS_NEMESIS"
	}
	else
		g_szClass[id] = "CLASS_ASSASSIN"
}

public zp_user_humanized_post(id, survivor, sniper)
{
	if (!sniper)
	{
		if (!survivor)
		{
#if !defined ZP_COMPAT
			zpnm_get_class_name(1, zpnm_get_user_human_class(id), g_szClass[id], 31)
#else
			g_szClass[id] = "CLASS_HUMAN"
#endif
		}
		else
			g_szClass[id] = "CLASS_SURVIVOR"
	}
	else
		g_szClass[id] = "CLASS_SNIPER"
}

public fw_PlayerKilled_Post(id)
	ClearSyncHud(id, g_msgSyncHUD)

public ShowStatus(id)
{
	if (!is_user_connected(id))
		return;
	
#if defined DEBUG
	new iAdmin;
	
	if (get_user_flags(id) & ADMIN_IMMUNITY)
	{
		iAdmin = true;
		client_print(id, print_console, "--->>> ShowStatus event called")
	}
#endif
	
	if (pev(id, pev_iuser2) || is_user_bot(id))
	{
#if defined DEBUG
		if (iAdmin)
			client_print(id, print_console, "--->>> Aimer is attached to a player or aimer is a bot !!!")
#endif
		return;
	}
	
#if defined DEBUG
	if (iAdmin)
		client_print(id, print_console, "--->>> Aimer is OK")
#endif
	
	new iAimID = read_data(2);
	
	if (!is_user_alive(iAimID))
	{
#if defined DEBUG
		if (iAdmin)
			client_print(id, print_console, "--->>> Target with ID #%d is invalid or not alive !!! Hiding the HUD message !!!", iAimID)
#endif
		ClearSyncHud(id, g_msgSyncHUD)
		
		return;
	}
	
#if defined DEBUG
	if (iAdmin)
		client_print(id, print_console, "--->>> Target with ID #%d is OK. Showing the HUD message.", iAimID)
#endif
	
	new iAlive = is_user_alive(id), iZombie = zp_get_user_zombie(id);
	
	if (!iZombie || !iAlive)
		set_hudmessage(g_nvg_zred, g_nvg_zgreen, g_nvg_zblue, -1.0, 0.5377, 1, 0.01, 75.77, 0.01, 0.01, -1)
	else
		set_hudmessage(g_nvg_hred, g_nvg_hgreen, g_nvg_hblue, -1.0, 0.5377, 1, 0.01, 75.77, 0.01, 0.01, -1)
	
	if (iAlive && iZombie != zp_get_user_zombie(iAimID))
	{
		if (containi(g_szClass[iAimID], "CLASS_") == -1)
			ShowSyncHudMsg(id, g_msgSyncHUD, "[%s]^n[%L %s]^n[%s]", g_szName[iAimID], id, "CLASS_CLASS", g_szClass[iAimID], g_szCountry[iAimID])
		else
			ShowSyncHudMsg(id, g_msgSyncHUD, "[%s]^n[%L %L]^n[%s]", g_szName[iAimID], id, "CLASS_CLASS", id, g_szClass[iAimID], g_szCountry[iAimID])
	}
	else
	{
		if (containi(g_szClass[iAimID], "CLASS_") == -1)
			ShowSyncHudMsg(id, g_msgSyncHUD, "[%s]^n[%L: %d]^n[%L: %d]^n[%L %d]^n[%L %s]^n[%s]", g_szName[iAimID], id, "ZOMBIE_ATTRIB1", get_user_health(iAimID), id,
			"ZOMBIE_ATTRIB5", get_user_armor(iAimID), id, "AMMO_PACKS1", zp_get_user_ammo_packs(iAimID), id, "CLASS_CLASS", g_szClass[iAimID], g_szCountry[iAimID])
		else
			ShowSyncHudMsg(id, g_msgSyncHUD, "[%s]^n[%L: %d]^n[%L: %d]^n[%L %d]^n[%L %L]^n[%s]", g_szName[iAimID], id, "ZOMBIE_ATTRIB1", get_user_health(iAimID), id,
			"ZOMBIE_ATTRIB5", get_user_armor(iAimID), id, "AMMO_PACKS1", zp_get_user_ammo_packs(iAimID), id, "CLASS_CLASS", id, g_szClass[iAimID], g_szCountry[iAimID])
	}
}

public HideStatus(id)
	ClearSyncHud(id, g_msgSyncHUD)
