/*
To do:

T = needs testing
X = done
- = cancelled

[X] zp43 support
[X] customizable information shown depending on the aimer and target type
[ ] customizable hud color for when aiming on team or enemy
[ ] zp5 support
[ ] optimize fwEventStatusValueShow (remove unnecessary checks)
[ ] optimize client_putinserver (string code)
[ ] use a single hud channel instead of auto (-1)
[ ] fix information not disappearing after switching spectating modes (free look / chase / first person)
[ ] customizable hud effects, position, hold time, etc
[ ] customizable information shown depending on aimer access
[X] constant iID for fwEventStatusValueHide
[X] remove_task on disconnect only if ZP43 compatibility isn't enabled
[ ] fix fwEventStatusValueShow triggering twice, first with random information
[ ] fix hud not showing when aiming at an enemy after previously aiming at a teammate
[X] fix armor lang missing on default ZP43(register zombie_plague_nightmare.txt anyway)
[ ] make the hud update in real time as the player stats change and is being aimed on
*/

// Modules
#include <amxmodx>
#include <geoip>
#include <fakemeta>
#include <hamsandwich>

//#define g_DefZP43Compatibility

// Plug-in APIs
#include <cs_ham_bots_api>
#if !defined g_DefZP43Compatibility
#include <zombieplaguenightmare>
#else
#include <zombieplague>
#endif

// Stocks
#include <bitsums>
//#include <d7_debug>

//const PEV_SPEC_TARGET = pev_iuser2
//
enum _:g_iBsInfo (<<= 1)
{
	g_iBitName = 1,
	g_iBitClass,
	g_iBitHealth,
	g_iBitArmor,
	g_iBitAmmoPacks,
	g_iBitCountry
}

new g_iID_MsgSyncHUD, g_szName[33][31], g_szClass[33][32], g_szCountry[33][51],

g_iID_PCvarInfoHTeam, g_iID_PCvarInfoHEnemy, g_iID_PCvarInfoZTeam, g_iID_PCvarInfoZEnemy, g_iID_PCvarInfoNeutral,
g_iCacheCvarInfoHTeam, g_iCacheCvarInfoHEnemy, g_iCacheCvarInfoZTeam, g_iCacheCvarInfoZEnemy, g_iCacheCvarInfoNeutral,

g_iID_PCvarHudColorRH, g_iID_PCvarHudColorGH, g_iID_PCvarHudColorBH,
g_iID_PCvarHudColorRZ, g_iID_PCvarHudColorGZ, g_iID_PCvarHudColorBZ,
g_iID_PCvarHudColorRS, g_iID_PCvarHudColorGS, g_iID_PCvarHudColorBS,
g_iCacheCvarHudColorRH, g_iCacheCvarHudColorGH, g_iCacheCvarHudColorBH,
g_iCacheCvarHudColorRZ, g_iCacheCvarHudColorGZ, g_iCacheCvarHudColorBZ,
g_iCacheCvarHudColorRS, g_iCacheCvarHudColorGS, g_iCacheCvarHudColorBS,

g_iBsConnected, g_iBsBot, g_iBsAlive, g_iBsZombie;

#if !defined g_DefZP43Compatibility
new g_iAmmoPacks[33];
#endif

public plugin_init()
{
	register_plugin("[ZPNM] Aim Info", "2.0.3", "D i 5 7 i n c T, @bdul!, Sn!ff3r, Numb, NiHiLaNTh")
	
	register_event("HLTV", "fwEventHLTVRoundStart", "a", "1=0", "2=0")
	register_event("StatusValue", "fwEventStatusValueShow", "b", "1!3", "2>0")
	register_event("StatusValue", "fwEventStatusValueHide", "b", "2=0")
	
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
	
	#if defined g_DefZP43Compatibility
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayer", 1)
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayer", 1)
	#endif
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	new szInfo[3];
	
	num_to_str(g_iBsInfo - 1, szInfo, charsmax(szInfo))
	g_iID_PCvarInfoHTeam = register_cvar("D7ZPAimInfoHTeam", szInfo);
	
	num_to_str(g_iBitName + g_iBitClass + g_iBitCountry, szInfo, charsmax(szInfo))
	g_iID_PCvarInfoHEnemy = register_cvar("D7ZPAimInfoHEnemy", szInfo);
	
	num_to_str(g_iBsInfo - 1 - g_iBitArmor, szInfo, charsmax(szInfo))
	g_iID_PCvarInfoZTeam = register_cvar("D7ZPAimInfoZTeam", szInfo);
	
	num_to_str(g_iBitName + g_iBitClass + g_iBitCountry, szInfo, charsmax(szInfo))
	g_iID_PCvarInfoZEnemy = register_cvar("D7ZPAimInfoZEnemy", szInfo);
	
	num_to_str(g_iBsInfo - 1, szInfo, charsmax(szInfo))
	g_iID_PCvarInfoNeutral = register_cvar("D7ZPAimInfoNeutral", szInfo);
	
	g_iID_PCvarHudColorRH = register_cvar("D7ZPAimInfoHudColorRH", "255");
	g_iID_PCvarHudColorGH = register_cvar("D7ZPAimInfoHudColorGH", "0");
	g_iID_PCvarHudColorBH = register_cvar("D7ZPAimInfoHudColorBH", "0");
	
	g_iID_PCvarHudColorRZ = register_cvar("D7ZPAimInfoHudColorRZ", "0");
	g_iID_PCvarHudColorGZ = register_cvar("D7ZPAimInfoHudColorGZ", "0");
	g_iID_PCvarHudColorBZ = register_cvar("D7ZPAimInfoHudColorBZ", "255");
	
	g_iID_PCvarHudColorRS = register_cvar("D7ZPAimInfoHudColorRS", "0");
	g_iID_PCvarHudColorGS = register_cvar("D7ZPAimInfoHudColorGS", "255");
	g_iID_PCvarHudColorBS = register_cvar("D7ZPAimInfoHudColorBS", "0");
	
	g_iID_MsgSyncHUD = CreateHudSyncObj();
	
	//ftD7Log(_, _, "[plugin_init] g_iBsInfo: %d.", g_iBsInfo)
	//ftD7Log(_, _, "[plugin_init] g_iBitName: %d.", g_iBitName)
	//ftD7Log(_, _, "[plugin_init] g_iBitClass: %d.", g_iBitClass)
	//ftD7Log(_, _, "[plugin_init] g_iBitHealth: %d.", g_iBitHealth)
	//ftD7Log(_, _, "[plugin_init] g_iBitArmor: %d.", g_iBitArmor)
	//ftD7Log(_, _, "[plugin_init] g_iBitAmmoPacks: %d.", g_iBitAmmoPacks)
	//ftD7Log(_, _, "[plugin_init] g_iBitCountry: %d.", g_iBitCountry)
}

public fwEventHLTVRoundStart()
{
	g_iCacheCvarInfoHTeam = get_pcvar_num(g_iID_PCvarInfoHTeam);
	g_iCacheCvarInfoHEnemy = get_pcvar_num(g_iID_PCvarInfoHEnemy);
	
	g_iCacheCvarInfoZTeam = get_pcvar_num(g_iID_PCvarInfoZTeam);
	g_iCacheCvarInfoZEnemy = get_pcvar_num(g_iID_PCvarInfoZEnemy);
	
	g_iCacheCvarInfoNeutral = get_pcvar_num(g_iID_PCvarInfoNeutral);
	
	
	
	g_iCacheCvarHudColorRH = get_pcvar_num(g_iID_PCvarHudColorRH);
	g_iCacheCvarHudColorGH = get_pcvar_num(g_iID_PCvarHudColorGH);
	g_iCacheCvarHudColorBH = get_pcvar_num(g_iID_PCvarHudColorBH);
	
	g_iCacheCvarHudColorRZ = get_pcvar_num(g_iID_PCvarHudColorRZ);
	g_iCacheCvarHudColorGZ = get_pcvar_num(g_iID_PCvarHudColorGZ);
	g_iCacheCvarHudColorBZ = get_pcvar_num(g_iID_PCvarHudColorBZ);
	
	g_iCacheCvarHudColorRS = get_pcvar_num(g_iID_PCvarHudColorRS);
	g_iCacheCvarHudColorGS = get_pcvar_num(g_iID_PCvarHudColorGS);
	g_iCacheCvarHudColorBS = get_pcvar_num(g_iID_PCvarHudColorBS);
}

public client_putinserver(iID)
{
	bitsum_add(g_iBsConnected, iID)
	
	if (is_user_bot(iID))
		bitsum_add(g_iBsBot, iID)
	
	static szIP[16];
	get_user_ip(iID, szIP, charsmax(szIP), 1)
	geoip_country(szIP, g_szCountry[iID])
	
	if (equali(g_szCountry[iID], "error"))
	{
		g_szCountry[iID] = "Country N/A"
		
		return;
	}
	
	new szCountryShort[4];
	geoip_code3_ex(szIP, szCountryShort)
	format(g_szCountry[iID], charsmax(g_szCountry[]), "%s(%s)", g_szCountry[iID], szCountryShort)
}

public client_disconnect(iID)
{
	#if !defined g_DefZP43Compatibility
	remove_task(iID)
	#endif
	
	bitsum_del(g_iBsConnected, iID)
	bitsum_del(g_iBsBot, iID)
	bitsum_del(g_iBsAlive, iID)
	bitsum_del(g_iBsZombie, iID)
}

public client_infochanged(iID)
{
	if (!bitsum_get(g_iBsConnected, iID))
		return;
	
	get_user_info(iID, "name", g_szName[iID], charsmax(g_szName[]))
}

#if !defined g_DefZP43Compatibility
public zpnm_user_spawn_post(iID)
{
	bitsum_add(g_iBsAlive, iID)
	bitsum_del(g_iBsZombie, iID)
	
	zpnm_get_class_name(1, zpnm_get_user_human_class(iID), g_szClass[iID], charsmax(g_szClass[]))
}
#else
public fwHamSpawnPlayer(const iID)
{
	if (is_user_alive(iID))
		bitsum_add(g_iBsAlive, iID)
	
	if (zp_get_user_zombie(iID))
		return;
	
	bitsum_del(g_iBsZombie, iID)
	
	g_szClass[iID] = "CLASS_HUMAN"
}
#endif

#if !defined g_DefZP43Compatibility
public zp_user_infected_post(iID, iID_Infector, bNemesis, bAssassin)
{
	bitsum_add(g_iBsZombie, iID)
	
	if (!bAssassin)
	{
		if (!bNemesis)
		{
			zpnm_get_class_name(0, zp_get_user_zombie_class(iID), g_szClass[iID], charsmax(g_szClass[]))
		}
		else
		{
			g_szClass[iID] = "CLASS_NEMESIS"
		}
	}
	else
	{
		g_szClass[iID] = "CLASS_ASSASSIN"
	}
}
#else
public zp_user_infected_post(iID, iID_Infector, bNemesis)
{
	bitsum_add(g_iBsZombie, iID)
	
	if (!bNemesis)
	{
		g_szClass[iID] = "CLASS_ZOMBIE"
	}
	else
	{
		g_szClass[iID] = "CLASS_NEMESIS"
	}
}
#endif

#if !defined g_DefZP43Compatibility
public zp_user_humanized_post(iID, bSurvivor, bSniper)
{
	bitsum_del(g_iBsZombie, iID)
	
	if (!bSniper)
	{
		if (!bSurvivor)
		{
			zpnm_get_class_name(1, zpnm_get_user_human_class(iID), g_szClass[iID], charsmax(g_szClass[]))
		}
		else
		{
			g_szClass[iID] = "CLASS_SURVIVOR"
		}
	}
	else
	{
		g_szClass[iID] = "CLASS_SNIPER"
	}
}
#else
public zp_user_humanized_post(iID, bSurvivor)
{
	bitsum_del(g_iBsZombie, iID)
	
	if (!bSurvivor)
	{
		g_szClass[iID] = "CLASS_HUMAN"
	}
	else
	{
		g_szClass[iID] = "CLASS_SURVIVOR"
	}
}
#endif

public fwHamKilledPlayer(const iID)
{
	bitsum_del(g_iBsAlive, iID)
	
	ClearSyncHud(iID, g_iID_MsgSyncHUD)
}

#if !defined g_DefZP43Compatibility
public zpnm_user_get_ammo_packs(iID)
{
	g_iAmmoPacks[iID] = zp_get_user_ammo_packs(iID);
}

public zp_extra_item_selected(iID, iItemID, bIgnoreCost, iCost)
{
	if (bIgnoreCost || !iCost)
		return;
	
	remove_task(iID)
	set_task(0.1, "fwTaskUpdateAmmoPacks", iID)
}

public fwTaskUpdateAmmoPacks(const iID)
{
	g_iAmmoPacks[iID] = zp_get_user_ammo_packs(iID);
}
#endif

public fwEventStatusValueShow(const iID)
{
	if (!bitsum_get(g_iBsConnected, iID)
	|| bitsum_get(g_iBsBot, iID)
	|| pev(iID, pev_iuser2))
		return;
	
	new iID_Aim = read_data(2);
	
	if (!bitsum_get(g_iBsAlive, iID_Aim))
	{
		ClearSyncHud(iID, g_iID_MsgSyncHUD)
		
		return;
	}
	
	new iBsInfo;
	
	if (!bitsum_get(g_iBsAlive, iID))
	{
		set_hudmessage(g_iCacheCvarHudColorRS, g_iCacheCvarHudColorGS, g_iCacheCvarHudColorBS, -1.0, 0.5377, 1, 0.01, 75.77, 0.01, 0.01, -1)
		
		iBsInfo = g_iCacheCvarInfoNeutral;
		//ftD7Log(_, _, "[fwEventStatusValueShow] iID %d is dead. iBsInfo: %d.", iID, iBsInfo)
	}
	else if (!bitsum_get(g_iBsZombie, iID))
	{
		//ftD7Log(_, _, "[fwEventStatusValueShow] iID %d is human.", iID)
		set_hudmessage(g_iCacheCvarHudColorRH, g_iCacheCvarHudColorGH, g_iCacheCvarHudColorBH, -1.0, 0.5377, 1, 0.01, 75.77, 0.01, 0.01, -1)
		
		if (!bitsum_get(g_iBsZombie, iID_Aim))
		{
			iBsInfo = g_iCacheCvarInfoHTeam;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iID_Aim %d is human. iBsInfo: %d.", iID_Aim, iBsInfo)
		}
		else
		{
			iBsInfo = g_iCacheCvarInfoHEnemy;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iID_Aim %d is zombie. iBsInfo: %d.", iID_Aim, iBsInfo)
		}
	}
	else
	{
		//ftD7Log(_, _, "[fwEventStatusValueShow] iID %d is zombie.", iID)
		set_hudmessage(g_iCacheCvarHudColorRZ, g_iCacheCvarHudColorGZ, g_iCacheCvarHudColorBZ, -1.0, 0.5377, 1, 0.01, 75.77, 0.01, 0.01, -1)
		
		if (bitsum_get(g_iBsZombie, iID_Aim))
		{
			iBsInfo = g_iCacheCvarInfoZTeam;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iID_Aim %d is zombie. iBsInfo: %d.", iID_Aim, iBsInfo)
		}
		else
		{
			iBsInfo = g_iCacheCvarInfoZEnemy;
			//ftD7Log(_, _, "[fwEventStatusValueShow] iID_Aim %d is human. iBsInfo: %d.", iID_Aim, iBsInfo)
		}
	}
	
	static szMessage[256];
	new iPosition;
	
	if (iBsInfo & g_iBitName)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%s]^n", g_szName[iID_Aim]);
		//ftD7Log(_, _, "[%s]", g_szName[iID_Aim]);
	}
	
	if (iBsInfo & g_iBitClass)
	{
		#if !defined g_DefZP43Compatibility
		if (contain(g_szClass[iID_Aim], "CLASS_") == -1)
		{
			iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %s]^n", iID, "CLASS_CLASS", g_szClass[iID_Aim]);
			//ftD7Log(_, _, "[%L %s]", iID, "CLASS_CLASS", g_szClass[iID_Aim]);
		}
		else
		{
		#endif
			iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %L]^n", iID, "CLASS_CLASS", iID, g_szClass[iID_Aim]);
			//ftD7Log(_, _, "[%L %L]", iID, "CLASS_CLASS", iID, g_szClass[iID_Aim]);
		#if !defined g_DefZP43Compatibility
		}
		#endif
	}
	
	if (iBsInfo & g_iBitHealth)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L: %d]^n", iID, "ZOMBIE_ATTRIB1", get_user_health(iID_Aim));
		//ftD7Log(_, _, "[%L: %d]", iID, "ZOMBIE_ATTRIB1", get_user_health(iID_Aim));
	}
	
	if (iBsInfo & g_iBitArmor)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L: %d]^n", iID, "ZOMBIE_ATTRIB5", get_user_armor(iID_Aim));
		//ftD7Log(_, _, "[%L: %d]", iID, "ZOMBIE_ATTRIB5", get_user_armor(iID_Aim));
	}
	
	if (iBsInfo & g_iBitAmmoPacks)
	{
		#if !defined g_DefZP43Compatibility
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %d]^n", iID, "AMMO_PACKS1", g_iAmmoPacks[iID_Aim]);
		//ftD7Log(_, _, "[%L %d]", iID, "AMMO_PACKS1", g_iAmmoPacks[iID_Aim]);
		#else
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%L %d]^n", iID, "AMMO_PACKS1", zp_get_user_ammo_packs(iID_Aim));
		//ftD7Log(_, _, "[%L %d]", iID, "AMMO_PACKS1", zp_get_user_ammo_packs(iID_Aim));
		#endif
	}
	
	if (iBsInfo & g_iBitCountry)
	{
		iPosition += formatex(szMessage[iPosition], charsmax(szMessage) - iPosition, "[%s]", g_szCountry[iID_Aim]);
		//ftD7Log(_, _, "[%s]", g_szCountry[iID_Aim]);
	}
	
	if (iBsInfo > 0)
		ShowSyncHudMsg(iID, g_iID_MsgSyncHUD, szMessage)
}

public fwEventStatusValueHide(const iID)
	ClearSyncHud(iID, g_iID_MsgSyncHUD)
