/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.2.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_IconStatus, g_icon[33][10], g_col_flare[11], g_nvgcol_zm[3],
g_assround, g_nvgcol_ass[3], g_enabled_fire, g_enabled_frost,
g_enabled_flare, g_enabled_infbomb

public plugin_init() 
{
	register_plugin("[ZPNM] Grenade Status", "1.2.2", "rapara13, D i 5 7 i n c T")
	
	register_event("CurWeapon", "event_curweapon", "be", "1=1")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_IconStatus = get_user_msgid("StatusIcon")
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	new pointer
	
	pointer = get_cvar_pointer("zp_fire_grenades")
	g_enabled_fire = get_pcvar_num(pointer)
	pointer = get_cvar_pointer("zp_frost_grenades")
	g_enabled_frost = get_pcvar_num(pointer)
	pointer = get_cvar_pointer("zp_flare_grenades")
	g_enabled_flare = get_pcvar_num(pointer)
	pointer = get_cvar_pointer("zp_extra_infbomb")
	g_enabled_infbomb = get_pcvar_num(pointer)
	
	if (g_enabled_infbomb)
	{
		pointer = get_cvar_pointer("zp_nvg_color_R")
		g_nvgcol_zm[0] = get_pcvar_num(pointer)
		pointer = get_cvar_pointer("zp_nvg_color_G")
		g_nvgcol_zm[1] = get_pcvar_num(pointer)
		pointer = get_cvar_pointer("zp_nvg_color_B")
		g_nvgcol_zm[2] = get_pcvar_num(pointer)
	}
	
	if (!g_enabled_flare)
		return;
	
	pointer = get_cvar_pointer("zp_flare_color")
	get_pcvar_string(pointer, g_col_flare, 10)
	static red[4], green[4], blue[4]
	parse(g_col_flare, red, 3, green, 3, blue, 3)
	
	if (!green[0])
		switch (get_pcvar_num(pointer))
		{
			case 0: // white
			{
				g_col_flare[0] = 255 // r
				g_col_flare[1] = 255 // g
				g_col_flare[2] = 255 // b
			}
			case 1: // red
			{
				g_col_flare[0] = 255 // r
				g_col_flare[1] = 0 // g
				g_col_flare[2] = 0 // b
			}
			case 2: // green
			{
				g_col_flare[0] = 0 // r
				g_col_flare[1] = 255 // g
				g_col_flare[2] = 0 // b
			}
			case 3: // blue
			{
				g_col_flare[0] = 0 // r
				g_col_flare[1] = 0 // g
				g_col_flare[2] = 255 // b
			}
			case 4: g_col_flare[0] = -2 // random (all colors)
			case 5: g_col_flare[0] = -1 // random (r,g,b)
		}
	else
	{
		g_col_flare[0] = clamp(str_to_num(red), 0, 255)
		g_col_flare[1] = clamp(str_to_num(green), 0, 255)
		g_col_flare[2] = clamp(str_to_num(blue), 0, 255)
	}
	
	pointer = get_cvar_pointer("zpnm_nvg_ass_color_R")
	g_nvgcol_ass[0] = get_pcvar_num(pointer)
	pointer = get_cvar_pointer("zpnm_nvg_ass_color_G")
	g_nvgcol_ass[1] = get_pcvar_num(pointer)
	pointer = get_cvar_pointer("zpnm_nvg_ass_color_B")
	g_nvgcol_ass[2] = get_pcvar_num(pointer)
}

public zp_round_started(mode)
	if (g_enabled_flare)
	{
		if (mode != MODE_ASSASSIN)
			g_assround = false
		else
			g_assround = true
	}

public zp_round_ended()
	if (g_enabled_flare)
		g_assround = false

public fwHamKilledPlayer(const iID)
	if (!is_user_bot(iID))
		remove_icon(iID)

public event_curweapon(iID) 
{
	if (is_user_bot(iID))
		return;
	
	remove_icon(iID)
	
	if (get_user_weapon(iID) != CSW_HEGRENADE
	&& get_user_weapon(iID) != CSW_FLASHBANG
	&& get_user_weapon(iID) != CSW_SMOKEGRENADE)
		return;
	
	static red, green, blue
	
	switch (get_user_weapon(iID)) 
	{
		case CSW_HEGRENADE: // Fire Nade
		{
			if (!zp_get_user_zombie(iID))
			{
				if (!g_enabled_fire)
					return;
				
				g_icon[iID] = "dmg_heat"
				
				red = 200
				green = 0
				blue = 0
			}
			else
			{
				if (!g_enabled_infbomb)
					return;
				
				g_icon[iID] = "dmg_bio"
				
				red = g_nvgcol_zm[0]
				green = g_nvgcol_zm[1]
				blue = g_nvgcol_zm[2]
			}
		}
		case CSW_FLASHBANG: // Frost Nade
		{
			if (!g_enabled_frost)
				return;
			
			g_icon[iID] = "dmg_cold"
			
			red = 0
			green = 100
			blue = 200
		}
		case CSW_SMOKEGRENADE: // Flare Nade
		{
			if (!g_enabled_flare)
				return;
			
			g_icon[iID] = "dmg_shock"
			
			if (g_assround)
			{
				red = g_nvgcol_ass[0]
				green = g_nvgcol_ass[1]
				blue = g_nvgcol_ass[2]
			}
			else if (g_col_flare[0] > -1)
			{
				red = g_col_flare[0]
				green = g_col_flare[1]
				blue = g_col_flare[2]
			}
			else if (g_col_flare[0] == -1)
			{
				switch (random_num(1, 3))
				{
					case 1:
					{
						red = random_num(175, 255)
						green = 0
						blue = 0
					}
					case 2:
					{
						red = 0
						green = random_num(175, 255)
						blue = 0
					}
					case 3:
					{
						red = 0
						green = 0
						blue = random_num(175, 255)
					}
				}
			}
			else if (g_col_flare[0] == -2)
			{
				red = random_num(75, 255)
				green = random_num(0, 255)
				blue = random_num(0, 255)
			}
		}
	}
	
	if (!red && !green && !blue)
		return;
	
	// show grenade icons
	message_begin(MSG_ONE, g_IconStatus, {0, 0, 0}, iID)
	write_byte(1) // status (0=hide, 1=show, 2=flash)
	write_string(g_icon[iID]) // sprite name
	write_byte(red) // red
	write_byte(green) // green
	write_byte(blue) // blue
	message_end()
}

remove_icon(iID) 
{
	// remove grenade icons
	message_begin(MSG_ONE, g_IconStatus, {0, 0, 0}, iID)
	write_byte(0) // status (0=hide, 1=show, 2=flash)
	write_string(g_icon[iID]) // sprite name
	message_end()
}
