/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v1.5.2
[T] fix class being set as false on spawn infect
[T] bitsums instead of array
[X] descriptive variable and constant names
[T] bigger player model array size just in case
[T] set or unset class bitsum on infect pre
[T] charsmax instead of exact values
[-] fix custom weapon models that use knife slot like bazooka being used for the zombie knife model?
[T] allow custom weapon models that use knife slot like bazooka to be used for the zombie knife model?
[X] use zpnm spawn and killed forwards instead of ham
[X] default player model to sas
[T] fix unwanted parameter being passed on zp_override_user_model
[T] zombie bitsum to optimize checking via native on infected pre
[T] model check and change task
[T] optimize
v1.6.5
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
//#include <hamsandwich>

// Plug-in APIs
//#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>
//#include <D7Debug>



new g_iIDClass, g_iBsHalfInfected, g_iBsZombie, g_szPlayerModel[33][64], g_szPlayerKnifeModel[33][64];

enum (+= 32)
{
	g_iIDTaskModelCheckChange = 32
}

new const g_szDefaultKnifeModel[] = "models/p_knife.mdl";

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	// Zombie Attributes
	new const zclass_name[] = "Half Infected Zombie" // name
	new const zclass_info[] = "Looks like humans" // description
	new const zclass_model[] = "sas" // model
	new const zclass_clawmodel[] = "v_knife.mdl" // claw model
	const zclass_health = 1600 // health
	const zclass_speed = 190 // speed
	const Float:zclass_gravity = 1.0 // gravity
	const Float:zclass_knockback = 1.0 // knockback
	
	// Register the new class and store ID for reference
	g_iIDClass = zp_register_zombie_class(zclass_name, zclass_info, zclass_model, zclass_clawmodel, zclass_health, zclass_speed, zclass_gravity, zclass_knockback);
	
	precache_model(g_szDefaultKnifeModel)
}

public plugin_init()
{
	register_plugin("[ZPNM] Half Infected Zombie", "1.6.5", "D i 5 7 i n c T")
	
	register_message(get_user_msgid("CurWeapon"), "fwMsgCurWeapon")
	
	//RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayer", 1)
	//RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	//RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayer", 1)
	//RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public client_disconnect(iID)
{
	remove_task(iID + g_iIDTaskModelCheckChange)
	
	bitsum_del(g_iBsZombie, iID)
	bitsum_del(g_iBsHalfInfected, iID)
}

public zpnm_user_spawn_post(iID)//fwHamSpawnPlayer
{
	remove_task(iID + g_iIDTaskModelCheckChange)
	
	bitsum_del(g_iBsZombie, iID)
	bitsum_del(g_iBsHalfInfected, iID)
}

public zp_user_infected_pre(iID, iIDInfector, bNemesis, bAssassin)
{
	// Check if the infected player is using our custom zombie class
	if (bNemesis || bAssassin || zp_get_user_zombie_class(iID) != g_iIDClass)
	{
		remove_task(iID + g_iIDTaskModelCheckChange)
		
		bitsum_del(g_iBsHalfInfected, iID)
		
		return;
	}
	
	bitsum_add(g_iBsHalfInfected, iID)
	
	if (bitsum_get(g_iBsZombie, iID))//zp_get_user_zombie(iID)
		return;
	
	zpnm_get_user_model(iID, g_szPlayerModel[iID], charsmax(g_szPlayerModel[]))
	
	if (get_user_weapon(iID) != CSW_KNIFE)
		engclient_cmd(iID, "weapon_knife")
	
	// Make sure we drop any custom weapons like bazooka, etc
	// so we won't have a zombie running around with them
	//engclient_cmd(iID, "drop; drop; drop; drop; drop; drop; drop")
	
	pev(iID, pev_weaponmodel2, g_szPlayerKnifeModel[iID], charsmax(g_szPlayerKnifeModel[]))
}

// User Infected forward
public zp_user_infected_post(iID, iIDInfector, bNemesis, bAssassin)
{
	bitsum_add(g_iBsZombie, iID)
	
	// Check if the infected player is using our custom zombie class
	if (!bitsum_get(g_iBsHalfInfected, iID))
	{
		return;
	}
	
	remove_task(iID + g_iIDTaskModelCheckChange)
	set_task(0.5, "fwTaskModelCheckChange", iID + g_iIDTaskModelCheckChange, _, _, "b")
	
	//zp_override_user_model(iID, g_szPlayerModel[iID])
	
	if (get_user_weapon(iID) == CSW_KNIFE)
	{
		if (g_szPlayerKnifeModel[iID][0])
			set_pev(iID, pev_weaponmodel2, g_szPlayerKnifeModel[iID])
		else
			set_pev(iID, pev_weaponmodel2, g_szDefaultKnifeModel)
	}
}

public fwTaskModelCheckChange(iID)
{
	iID -= g_iIDTaskModelCheckChange;
	
	static szModel[64];
	zpnm_get_user_model(iID, szModel, charsmax(szModel))
	
	//ftD7Log(_, _, "[fwTaskModelCheckChange] iID: %d. Current model: ^"%s^". Human model: ^"%s^".", iID, szModel, g_szPlayerModel[iID])
	
	if (equali(szModel, g_szPlayerModel[iID]))
	{
		//ftD7Log(_, _, "[fwTaskModelCheckChange] iID: %d. Waiting for the player model to change so we can change it back to our human model.", iID)
		
		return;
	}
	
	//ftD7Log(_, _, "[fwTaskModelCheckChange] iID: %d. Changing to our human model.", iID)
	
	zp_override_user_model(iID, g_szPlayerModel[iID])
	
	remove_task(iID + g_iIDTaskModelCheckChange)
}

public zp_user_humanized_post(iID)
{
	remove_task(iID + g_iIDTaskModelCheckChange)
	
	bitsum_del(g_iBsZombie, iID)
	bitsum_del(g_iBsHalfInfected, iID)
}

public zpnm_user_killed_pre(iID)//fwHamKilledPlayer
{
	remove_task(iID + g_iIDTaskModelCheckChange)
	
	bitsum_del(g_iBsZombie, iID)
	bitsum_del(g_iBsHalfInfected, iID)
}

public fwMsgCurWeapon(iIDMsg, iIDDest, iIDEntity)
{
	// Not an active weapon
	if (!bitsum_get(g_iBsHalfInfected, iIDEntity) || get_msg_arg_int(1) != 1 || get_user_weapon(iIDEntity) != CSW_KNIFE)
		return;
	
	if (g_szPlayerKnifeModel[iIDEntity][0])
		set_pev(iIDEntity, pev_weaponmodel2, g_szPlayerKnifeModel[iIDEntity])
	else
		set_pev(iIDEntity, pev_weaponmodel2, g_szDefaultKnifeModel)
}
