/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.0.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Zombie Attributes
new const zclass_name[] = "Incinerated Zombie" // name
new const zclass_info[] = "Can't be burned" // description
new const zclass_model[] = "zombie_source" // model
new const zclass_clawmodel[] = "zombie_plague/v_knife_zombie.mdl" // claw model
const zclass_health = 1800 // health
const zclass_speed = 190 // speed
const Float:zclass_gravity = 0.75 // gravity
const Float:zclass_knockback = 1.157 // knockback

// Class IDs
new g_zclass_incinerated, g_incinerated[33]

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	// Register the new class and store ID for reference
	g_zclass_incinerated = zp_register_zombie_class(zclass_name, zclass_info, zclass_model, zclass_clawmodel, zclass_health, zclass_speed, zclass_gravity, zclass_knockback)	
}

public plugin_init()
{
	register_plugin("[ZPNM] Incinerated Zombie Class", "1.0.2", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public client_disconnect(iID)
	g_incinerated[iID] = false

public zpnm_user_spawn_post(iID)
	g_incinerated[iID] = false

public zp_user_infected_post(iID, infector, nemesis, assassin)
{
	if (zp_get_user_zombie_class(iID) != g_zclass_incinerated || nemesis || assassin)
		return;
	
	g_incinerated[iID] = true
}

public zpnm_user_burn(iID, attacker)
{
	if (!g_incinerated[iID] || !attacker)
		return;
	
	zpnm_set_user_burning(iID, 0)
}

public zp_user_humanized_post(iID)
	g_incinerated[iID] = false

public fwHamKilledPlayer(const iID)
	g_incinerated[iID] = false
